unit frmMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, waveiox, msacmx, MMSystem;

type
  TFormMain = class(TForm)
    Button1: TButton;
    ProgressBar1: TProgressBar;
    Button2: TButton;
    OpenDialogSource: TOpenDialog;
    OpenDialogTarget: TOpenDialog;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
  public
    { Public declarations }
  end;

const
  BUFFER_SIZE = 4000;

var
  FormMain: TFormMain;

implementation

{$R *.DFM}

function mmioFourCC( Chr1: Char; Chr2: Char; Chr3: Char; Chr4: Char ): Longint;
begin
  Result := Integer(Chr1) + (Integer(Chr2) shl 8) + (Integer(Chr3) shl 16)
    + (Integer(Chr4) shl 24);
end;


procedure TFormMain.Button2Click(Sender: TObject);
begin
  Close;
end;

procedure TFormMain.Button1Click(Sender: TObject);
var
  f1, f2: String;
  w1, w2: TFileWaveStream;
  pcmw: TPCMWaveReader;
  l, p: Integer;
  buffer: array [0..BUFFER_SIZE-1] of Integer;
begin
  if OpenDialogSource.Execute then
  begin
    f1 := OpenDialogSource.FileName;
    if OpenDialogTarget.Execute then
    begin
      f2 := OpenDialogTarget.FileName;

      w1 := nil;
      w2 := nil;
      pcmw := nil;
      try
        w1 := TFileWaveStream.Create( f1, nil );
        pcmw := TPCMWaveReader.Create( w1 );
        w2 := TFileWaveStream.Create( f2, pcmw.Format );

        p := 0;
        l := pcmw.Read( buffer, BUFFER_SIZE );
        while (l > 0) do
        begin
          w2.Write( buffer, l );
          p := p + l;
          ProgressBar1.Position := (p * 100) div pcmw.Size;
          l := pcmw.Read( buffer, BUFFER_SIZE );
        end;
      finally
        w2.Free;
        pcmw.Free;
        w1.Free;
      end;
    end;
  end;

  ShowMessage('Done!');
  ProgressBar1.Position := 0;
end;

end.
